<?php

namespace MG;

/**
 * Class which returns the class map definition
 * @package MG
 */
class MGClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'BulkLoadContacts' => '\\MG\\StructType\\MGBulkLoadContacts',
            'WSImportDirectives' => '\\MG\\StructType\\MGWSImportDirectives',
            'ArrayOfWSFileMappings' => '\\MG\\ArrayType\\MGArrayOfWSFileMappings',
            'WSFileMappings' => '\\MG\\StructType\\MGWSFileMappings',
            'BulkLoadContactsResponse' => '\\MG\\StructType\\MGBulkLoadContactsResponse',
            'WSUser' => '\\MG\\StructType\\MGWSUser',
            'BulkLoadContactsWithOptions' => '\\MG\\StructType\\MGBulkLoadContactsWithOptions',
            'WSBulkLoadOptions' => '\\MG\\StructType\\MGWSBulkLoadOptions',
            'BulkLoadContactsWithOptionsResponse' => '\\MG\\StructType\\MGBulkLoadContactsWithOptionsResponse',
            'UpdateSubscribedContactAttribute' => '\\MG\\StructType\\MGUpdateSubscribedContactAttribute',
            'UpdateSubscribedContactAttributeResponse' => '\\MG\\StructType\\MGUpdateSubscribedContactAttributeResponse',
            'UpdateSubscribedContactAttributeWithOptions' => '\\MG\\StructType\\MGUpdateSubscribedContactAttributeWithOptions',
            'WSUpdateSubcribedContactAttributeOptions' => '\\MG\\StructType\\MGWSUpdateSubcribedContactAttributeOptions',
            'UpdateSubscribedContactAttributeWithOptionsResponse' => '\\MG\\StructType\\MGUpdateSubscribedContactAttributeWithOptionsResponse',
            'GetProcessStatus' => '\\MG\\StructType\\MGGetProcessStatus',
            'GetProcessStatusResponse' => '\\MG\\StructType\\MGGetProcessStatusResponse',
            'WSProcessStatus' => '\\MG\\StructType\\MGWSProcessStatus',
            'GetMessageStatus' => '\\MG\\StructType\\MGGetMessageStatus',
            'GetMessageStatusResponse' => '\\MG\\StructType\\MGGetMessageStatusResponse',
            'WSMessageStatus' => '\\MG\\StructType\\MGWSMessageStatus',
            'GetLegacyProcessStatus' => '\\MG\\StructType\\MGGetLegacyProcessStatus',
            'GetLegacyProcessStatusResponse' => '\\MG\\StructType\\MGGetLegacyProcessStatusResponse',
            'ArrayOfWSLegacyProcessStatus' => '\\MG\\ArrayType\\MGArrayOfWSLegacyProcessStatus',
            'WSLegacyProcessStatus' => '\\MG\\StructType\\MGWSLegacyProcessStatus',
            'ConductorBulkLoadAndTriggerContacts' => '\\MG\\StructType\\MGConductorBulkLoadAndTriggerContacts',
            'ArrayOfWSTriggerFileMappings' => '\\MG\\ArrayType\\MGArrayOfWSTriggerFileMappings',
            'WSTriggerFileMappings' => '\\MG\\StructType\\MGWSTriggerFileMappings',
            'ConductorBulkLoadAndTriggerContactsResponse' => '\\MG\\StructType\\MGConductorBulkLoadAndTriggerContactsResponse',
            'ConductorBulkLoadAndTriggerContactsWithOptions' => '\\MG\\StructType\\MGConductorBulkLoadAndTriggerContactsWithOptions',
            'WSConductorBulkLoadOptions' => '\\MG\\StructType\\MGWSConductorBulkLoadOptions',
            'ConductorBulkLoadAndTriggerContactsWithOptionsResponse' => '\\MG\\StructType\\MGConductorBulkLoadAndTriggerContactsWithOptionsResponse',
            'ConductorGetExternalEvents' => '\\MG\\StructType\\MGConductorGetExternalEvents',
            'ConductorGetExternalEventsResponse' => '\\MG\\StructType\\MGConductorGetExternalEventsResponse',
            'ArrayOfWSConductorExternalEvent' => '\\MG\\ArrayType\\MGArrayOfWSConductorExternalEvent',
            'WSConductorExternalEvent' => '\\MG\\StructType\\MGWSConductorExternalEvent',
            'ConductorGetConversations' => '\\MG\\StructType\\MGConductorGetConversations',
            'ConductorGetConversationsResponse' => '\\MG\\StructType\\MGConductorGetConversationsResponse',
            'ArrayOfWSConductorConversation' => '\\MG\\ArrayType\\MGArrayOfWSConductorConversation',
            'WSConductorConversation' => '\\MG\\StructType\\MGWSConductorConversation',
            'GetAccountVmtaCollection' => '\\MG\\StructType\\MGGetAccountVmtaCollection',
            'WSException' => '\\MG\\StructType\\MGWSException',
            'GetAccountVmtaCollectionResponse' => '\\MG\\StructType\\MGGetAccountVmtaCollectionResponse',
            'ArrayOfWSVmta' => '\\MG\\ArrayType\\MGArrayOfWSVmta',
            'WSVmta' => '\\MG\\StructType\\MGWSVmta',
            'GetContactList' => '\\MG\\StructType\\MGGetContactList',
            'GetContactListResponse' => '\\MG\\StructType\\MGGetContactListResponse',
            'WSContactList' => '\\MG\\StructType\\MGWSContactList',
            'GetContactListCollection' => '\\MG\\StructType\\MGGetContactListCollection',
            'GetContactListCollectionResponse' => '\\MG\\StructType\\MGGetContactListCollectionResponse',
            'ArrayOfWSContactList' => '\\MG\\ArrayType\\MGArrayOfWSContactList',
            'CreateContactList' => '\\MG\\StructType\\MGCreateContactList',
            'ArrayOfString' => '\\MG\\ArrayType\\MGArrayOfString_1',
            'CreateContactListResponse' => '\\MG\\StructType\\MGCreateContactListResponse',
            'UpdateContactList' => '\\MG\\StructType\\MGUpdateContactList',
            'WSUpdateContactList' => '\\MG\\StructType\\MGWSUpdateContactList',
            'UpdateContactListResponse' => '\\MG\\StructType\\MGUpdateContactListResponse',
            'CreateList' => '\\MG\\StructType\\MGCreateList',
            'WSList' => '\\MG\\StructType\\MGWSList',
            'CreateListResponse' => '\\MG\\StructType\\MGCreateListResponse',
            'AddGoogleTrackingDomainsToList' => '\\MG\\StructType\\MGAddGoogleTrackingDomainsToList',
            'AddGoogleTrackingDomainsToListResponse' => '\\MG\\StructType\\MGAddGoogleTrackingDomainsToListResponse',
            'DeleteGoogleTrackingDomainsFromList' => '\\MG\\StructType\\MGDeleteGoogleTrackingDomainsFromList',
            'DeleteGoogleTrackingDomainsFromListResponse' => '\\MG\\StructType\\MGDeleteGoogleTrackingDomainsFromListResponse',
            'DeleteContactList' => '\\MG\\StructType\\MGDeleteContactList',
            'DeleteContactListResponse' => '\\MG\\StructType\\MGDeleteContactListResponse',
            'GetProfileHeaderCollection' => '\\MG\\StructType\\MGGetProfileHeaderCollection',
            'GetProfileHeaderCollectionResponse' => '\\MG\\StructType\\MGGetProfileHeaderCollectionResponse',
            'ArrayOfWSProfileHeader' => '\\MG\\ArrayType\\MGArrayOfWSProfileHeader',
            'WSProfileHeader' => '\\MG\\StructType\\MGWSProfileHeader',
            'WSProfileAttribute' => '\\MG\\StructType\\MGWSProfileAttribute',
            'CreateProfileHeader' => '\\MG\\StructType\\MGCreateProfileHeader',
            'CreateProfileHeaderResponse' => '\\MG\\StructType\\MGCreateProfileHeaderResponse',
            'UpdateProfileHeader' => '\\MG\\StructType\\MGUpdateProfileHeader',
            'UpdateProfileHeaderResponse' => '\\MG\\StructType\\MGUpdateProfileHeaderResponse',
            'DeleteProfileHeader' => '\\MG\\StructType\\MGDeleteProfileHeader',
            'DeleteProfileHeaderResponse' => '\\MG\\StructType\\MGDeleteProfileHeaderResponse',
            'CreateProfileAttribute' => '\\MG\\StructType\\MGCreateProfileAttribute',
            'CreateProfileAttributeResponse' => '\\MG\\StructType\\MGCreateProfileAttributeResponse',
            'UpdateProfileAttribute' => '\\MG\\StructType\\MGUpdateProfileAttribute',
            'UpdateProfileAttributeResponse' => '\\MG\\StructType\\MGUpdateProfileAttributeResponse',
            'DeleteProfileAttribute' => '\\MG\\StructType\\MGDeleteProfileAttribute',
            'DeleteProfileAttributeResponse' => '\\MG\\StructType\\MGDeleteProfileAttributeResponse',
            'GetContact' => '\\MG\\StructType\\MGGetContact',
            'GetContactResponse' => '\\MG\\StructType\\MGGetContactResponse',
            'WSContact' => '\\MG\\StructType\\MGWSContact',
            'WSProfileAttributeValue' => '\\MG\\StructType\\MGWSProfileAttributeValue',
            'GetContactByEmailKey' => '\\MG\\StructType\\MGGetContactByEmailKey',
            'GetContactByEmailKeyResponse' => '\\MG\\StructType\\MGGetContactByEmailKeyResponse',
            'SetContact' => '\\MG\\StructType\\MGSetContact',
            'SetContactResponse' => '\\MG\\StructType\\MGSetContactResponse',
            'SendTransactionalMessage' => '\\MG\\StructType\\MGSendTransactionalMessage',
            'ArrayOfWSProfileAttributeValue' => '\\MG\\ArrayType\\MGArrayOfWSProfileAttributeValue',
            'SendTransactionalMessageResponse' => '\\MG\\StructType\\MGSendTransactionalMessageResponse',
            'GetTransactionalMessageCollection' => '\\MG\\StructType\\MGGetTransactionalMessageCollection',
            'GetTransactionalMessageCollectionResponse' => '\\MG\\StructType\\MGGetTransactionalMessageCollectionResponse',
            'ArrayOfWSTransactionalMessage' => '\\MG\\ArrayType\\MGArrayOfWSTransactionalMessage',
            'WSTransactionalMessage' => '\\MG\\StructType\\MGWSTransactionalMessage',
            'UpdateContact' => '\\MG\\StructType\\MGUpdateContact',
            'UpdateContactResponse' => '\\MG\\StructType\\MGUpdateContactResponse',
            'SubscribeFormPassThrough' => '\\MG\\StructType\\MGSubscribeFormPassThrough',
            'SubscribeFormPassThroughResponse' => '\\MG\\StructType\\MGSubscribeFormPassThroughResponse',
            'ChangeContactEmailAddress' => '\\MG\\StructType\\MGChangeContactEmailAddress',
            'ChangeContactEmailAddressResponse' => '\\MG\\StructType\\MGChangeContactEmailAddressResponse',
            'SubscribeContact' => '\\MG\\StructType\\MGSubscribeContact',
            'SubscribeContactResponse' => '\\MG\\StructType\\MGSubscribeContactResponse',
            'UnsubscribeContact' => '\\MG\\StructType\\MGUnsubscribeContact',
            'UnsubscribeContactResponse' => '\\MG\\StructType\\MGUnsubscribeContactResponse',
            'GetMessageAnalyticsInformation' => '\\MG\\StructType\\MGGetMessageAnalyticsInformation',
            'ArrayOfInt' => '\\MG\\ArrayType\\MGArrayOfInt',
            'GetMessageAnalyticsInformationResponse' => '\\MG\\StructType\\MGGetMessageAnalyticsInformationResponse',
            'ArrayOfWSMessageAnalyticsInformation' => '\\MG\\ArrayType\\MGArrayOfWSMessageAnalyticsInformation',
            'WSMessageAnalyticsInformation' => '\\MG\\StructType\\MGWSMessageAnalyticsInformation',
            'GetSpamScore' => '\\MG\\StructType\\MGGetSpamScore',
            'WSMessage' => '\\MG\\StructType\\MGWSMessage',
            'GetSpamScoreResponse' => '\\MG\\StructType\\MGGetSpamScoreResponse',
            'WSSpamScore' => '\\MG\\StructType\\MGWSSpamScore',
            'SpamAssassinScore' => '\\MG\\StructType\\MGSpamAssassinScore',
            'ScheduleSendListMessage' => '\\MG\\StructType\\MGScheduleSendListMessage',
            'ScheduleSendListMessageResponse' => '\\MG\\StructType\\MGScheduleSendListMessageResponse',
            'ScheduleSendListMessageWithProfileFilter' => '\\MG\\StructType\\MGScheduleSendListMessageWithProfileFilter',
            'ArrayOfWSProfileFilter' => '\\MG\\ArrayType\\MGArrayOfWSProfileFilter',
            'WSProfileFilter' => '\\MG\\StructType\\MGWSProfileFilter',
            'ScheduleSendListMessageWithProfileFilterResponse' => '\\MG\\StructType\\MGScheduleSendListMessageWithProfileFilterResponse',
            'SendListMessage' => '\\MG\\StructType\\MGSendListMessage',
            'SendListMessageResponse' => '\\MG\\StructType\\MGSendListMessageResponse',
            'SendListMessageWithProfileFilter' => '\\MG\\StructType\\MGSendListMessageWithProfileFilter',
            'SendListMessageWithProfileFilterResponse' => '\\MG\\StructType\\MGSendListMessageWithProfileFilterResponse',
            'SendListMessageTest' => '\\MG\\StructType\\MGSendListMessageTest',
            'SendListMessageTestResponse' => '\\MG\\StructType\\MGSendListMessageTestResponse',
            'SendListMessageReview' => '\\MG\\StructType\\MGSendListMessageReview',
            'SendListMessageReviewResponse' => '\\MG\\StructType\\MGSendListMessageReviewResponse',
            'GetCampaignCollection' => '\\MG\\StructType\\MGGetCampaignCollection',
            'GetCampaignCollectionResponse' => '\\MG\\StructType\\MGGetCampaignCollectionResponse',
            'ArrayOfWSCampaign' => '\\MG\\ArrayType\\MGArrayOfWSCampaign',
            'WSCampaign' => '\\MG\\StructType\\MGWSCampaign',
            'GetCharacterSetCollection' => '\\MG\\StructType\\MGGetCharacterSetCollection',
            'GetCharacterSetCollectionResponse' => '\\MG\\StructType\\MGGetCharacterSetCollectionResponse',
            'ArrayOfWSCharacterSet' => '\\MG\\ArrayType\\MGArrayOfWSCharacterSet',
            'WSCharacterSet' => '\\MG\\StructType\\MGWSCharacterSet',
            'SendSavedMessage' => '\\MG\\StructType\\MGSendSavedMessage',
            'SendSavedMessageResponse' => '\\MG\\StructType\\MGSendSavedMessageResponse',
            'SendSavedMessageTest' => '\\MG\\StructType\\MGSendSavedMessageTest',
            'SendSavedMessageTestResponse' => '\\MG\\StructType\\MGSendSavedMessageTestResponse',
            'GetSavedMessageCollection' => '\\MG\\StructType\\MGGetSavedMessageCollection',
            'GetSavedMessageCollectionResponse' => '\\MG\\StructType\\MGGetSavedMessageCollectionResponse',
            'ArrayOfWSSavedMessage' => '\\MG\\ArrayType\\MGArrayOfWSSavedMessage',
            'WSSavedMessage' => '\\MG\\StructType\\MGWSSavedMessage',
            'GetFilteredListCount' => '\\MG\\StructType\\MGGetFilteredListCount',
            'GetFilteredListCountResponse' => '\\MG\\StructType\\MGGetFilteredListCountResponse',
            'ReportSubscribedContacts' => '\\MG\\StructType\\MGReportSubscribedContacts',
            'ReportSubscribedContactsResponse' => '\\MG\\StructType\\MGReportSubscribedContactsResponse',
            'ArrayOfWSContactSubscriptionInfo' => '\\MG\\ArrayType\\MGArrayOfWSContactSubscriptionInfo',
            'WSContactSubscriptionInfo' => '\\MG\\StructType\\MGWSContactSubscriptionInfo',
            'ReportRangeSubscribedContacts' => '\\MG\\StructType\\MGReportRangeSubscribedContacts',
            'ReportRangeSubscribedContactsResponse' => '\\MG\\StructType\\MGReportRangeSubscribedContactsResponse',
            'ReportAdminContactFeedbackLoop' => '\\MG\\StructType\\MGReportAdminContactFeedbackLoop',
            'ReportAdminContactFeedbackLoopResponse' => '\\MG\\StructType\\MGReportAdminContactFeedbackLoopResponse',
            'ArrayOfWSFeedbackLoopListing' => '\\MG\\ArrayType\\MGArrayOfWSFeedbackLoopListing',
            'WSFeedbackLoopListing' => '\\MG\\StructType\\MGWSFeedbackLoopListing',
            'ReportMessageContactSent' => '\\MG\\StructType\\MGReportMessageContactSent',
            'ReportMessageContactSentResponse' => '\\MG\\StructType\\MGReportMessageContactSentResponse',
            'ArrayOfWSMessageRecipient' => '\\MG\\ArrayType\\MGArrayOfWSMessageRecipient',
            'WSMessageRecipient' => '\\MG\\StructType\\MGWSMessageRecipient',
            'ReportMessageContactOpen' => '\\MG\\StructType\\MGReportMessageContactOpen',
            'ReportMessageContactOpenResponse' => '\\MG\\StructType\\MGReportMessageContactOpenResponse',
            'ArrayOfWSContactOpen' => '\\MG\\ArrayType\\MGArrayOfWSContactOpen',
            'WSContactOpen' => '\\MG\\StructType\\MGWSContactOpen',
            'ReportRangeMessageContactOpen' => '\\MG\\StructType\\MGReportRangeMessageContactOpen',
            'ReportRangeMessageContactOpenResponse' => '\\MG\\StructType\\MGReportRangeMessageContactOpenResponse',
            'ReportMessageContactRead' => '\\MG\\StructType\\MGReportMessageContactRead',
            'ReportMessageContactReadResponse' => '\\MG\\StructType\\MGReportMessageContactReadResponse',
            'ArrayOfWSContactRead' => '\\MG\\ArrayType\\MGArrayOfWSContactRead',
            'WSContactRead' => '\\MG\\StructType\\MGWSContactRead',
            'ReportRangeMessageContactRead' => '\\MG\\StructType\\MGReportRangeMessageContactRead',
            'ReportRangeMessageContactReadResponse' => '\\MG\\StructType\\MGReportRangeMessageContactReadResponse',
            'ReportMessageContactClick' => '\\MG\\StructType\\MGReportMessageContactClick',
            'ReportMessageContactClickResponse' => '\\MG\\StructType\\MGReportMessageContactClickResponse',
            'ArrayOfWSContactClick' => '\\MG\\ArrayType\\MGArrayOfWSContactClick',
            'WSContactClick' => '\\MG\\StructType\\MGWSContactClick',
            'ReportRangeMessageContactClick' => '\\MG\\StructType\\MGReportRangeMessageContactClick',
            'ReportRangeMessageContactClickResponse' => '\\MG\\StructType\\MGReportRangeMessageContactClickResponse',
            'ReportMessageContactPassalong' => '\\MG\\StructType\\MGReportMessageContactPassalong',
            'ReportMessageContactPassalongResponse' => '\\MG\\StructType\\MGReportMessageContactPassalongResponse',
            'ArrayOfWSContactPassalong' => '\\MG\\ArrayType\\MGArrayOfWSContactPassalong',
            'WSContactPassalong' => '\\MG\\StructType\\MGWSContactPassalong',
            'ReportRangeMessageContactPassalong' => '\\MG\\StructType\\MGReportRangeMessageContactPassalong',
            'ReportRangeMessageContactPassalongResponse' => '\\MG\\StructType\\MGReportRangeMessageContactPassalongResponse',
            'ReportMessageContactBounces' => '\\MG\\StructType\\MGReportMessageContactBounces',
            'ReportMessageContactBouncesResponse' => '\\MG\\StructType\\MGReportMessageContactBouncesResponse',
            'ArrayOfWSContactBounce' => '\\MG\\ArrayType\\MGArrayOfWSContactBounce',
            'WSContactBounce' => '\\MG\\StructType\\MGWSContactBounce',
            'ReportRangeMessageContactBounces' => '\\MG\\StructType\\MGReportRangeMessageContactBounces',
            'ReportRangeMessageContactBouncesResponse' => '\\MG\\StructType\\MGReportRangeMessageContactBouncesResponse',
            'ReportListMessageActivity' => '\\MG\\StructType\\MGReportListMessageActivity',
            'ReportListMessageActivityResponse' => '\\MG\\StructType\\MGReportListMessageActivityResponse',
            'ArrayOfWSMessageActivity' => '\\MG\\ArrayType\\MGArrayOfWSMessageActivity',
            'WSMessageActivity' => '\\MG\\StructType\\MGWSMessageActivity',
            'ReportListMessageDelivery' => '\\MG\\StructType\\MGReportListMessageDelivery',
            'ReportListMessageDeliveryResponse' => '\\MG\\StructType\\MGReportListMessageDeliveryResponse',
            'ArrayOfWSMessageDelivery' => '\\MG\\ArrayType\\MGArrayOfWSMessageDelivery',
            'WSMessageDelivery' => '\\MG\\StructType\\MGWSMessageDelivery',
            'ReportListContactRemoval' => '\\MG\\StructType\\MGReportListContactRemoval',
            'ReportListContactRemovalResponse' => '\\MG\\StructType\\MGReportListContactRemovalResponse',
            'ArrayOfWSContactRemovalInfo' => '\\MG\\ArrayType\\MGArrayOfWSContactRemovalInfo',
            'WSContactRemovalInfo' => '\\MG\\StructType\\MGWSContactRemovalInfo',
            'ReportRangeListContactRemoval' => '\\MG\\StructType\\MGReportRangeListContactRemoval',
            'ReportRangeListContactRemovalResponse' => '\\MG\\StructType\\MGReportRangeListContactRemovalResponse',
            'ReportListContactHygiene' => '\\MG\\StructType\\MGReportListContactHygiene',
            'ReportListContactHygieneResponse' => '\\MG\\StructType\\MGReportListContactHygieneResponse',
            'ArrayOfWSContactHygieneInfo' => '\\MG\\ArrayType\\MGArrayOfWSContactHygieneInfo',
            'WSContactHygieneInfo' => '\\MG\\StructType\\MGWSContactHygieneInfo',
            'ReportRangeListContactHygiene' => '\\MG\\StructType\\MGReportRangeListContactHygiene',
            'ReportRangeListContactHygieneResponse' => '\\MG\\StructType\\MGReportRangeListContactHygieneResponse',
            'ReportMessageLinkClick' => '\\MG\\StructType\\MGReportMessageLinkClick',
            'ReportMessageLinkClickResponse' => '\\MG\\StructType\\MGReportMessageLinkClickResponse',
            'ArrayOfWSMessageLink' => '\\MG\\ArrayType\\MGArrayOfWSMessageLink',
            'WSMessageLink' => '\\MG\\StructType\\MGWSMessageLink',
            'ReportContactLinkClick' => '\\MG\\StructType\\MGReportContactLinkClick',
            'ReportContactLinkClickResponse' => '\\MG\\StructType\\MGReportContactLinkClickResponse',
            'ArrayOfWSContactLinkClick' => '\\MG\\ArrayType\\MGArrayOfWSContactLinkClick',
            'WSContactLinkClick' => '\\MG\\StructType\\MGWSContactLinkClick',
            'ReportMessageLocationClick' => '\\MG\\StructType\\MGReportMessageLocationClick',
            'ReportMessageLocationClickResponse' => '\\MG\\StructType\\MGReportMessageLocationClickResponse',
            'ArrayOfWSMessageLocationClick' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationClick',
            'WSMessageLocationClick' => '\\MG\\StructType\\MGWSMessageLocationClick',
            'ReportMessageLocationOpen' => '\\MG\\StructType\\MGReportMessageLocationOpen',
            'ReportMessageLocationOpenResponse' => '\\MG\\StructType\\MGReportMessageLocationOpenResponse',
            'ArrayOfWSMessageLocationOpen' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationOpen',
            'WSMessageLocationOpen' => '\\MG\\StructType\\MGWSMessageLocationOpen',
            'ReportMessageLocationRead' => '\\MG\\StructType\\MGReportMessageLocationRead',
            'ReportMessageLocationReadResponse' => '\\MG\\StructType\\MGReportMessageLocationReadResponse',
            'ArrayOfWSMessageLocationRead' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationRead',
            'WSMessageLocationRead' => '\\MG\\StructType\\MGWSMessageLocationRead',
            'ReportMessageLocationContactClick' => '\\MG\\StructType\\MGReportMessageLocationContactClick',
            'ReportMessageLocationContactClickResponse' => '\\MG\\StructType\\MGReportMessageLocationContactClickResponse',
            'ArrayOfWSMessageLocationContactClick' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationContactClick',
            'WSMessageLocationContactClick' => '\\MG\\StructType\\MGWSMessageLocationContactClick',
            'ReportMessageLocationContactOpen' => '\\MG\\StructType\\MGReportMessageLocationContactOpen',
            'ReportMessageLocationContactOpenResponse' => '\\MG\\StructType\\MGReportMessageLocationContactOpenResponse',
            'ArrayOfWSMessageLocationContactOpen' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationContactOpen',
            'WSMessageLocationContactOpen' => '\\MG\\StructType\\MGWSMessageLocationContactOpen',
            'ReportMessageLocationContactRead' => '\\MG\\StructType\\MGReportMessageLocationContactRead',
            'ReportMessageLocationContactReadResponse' => '\\MG\\StructType\\MGReportMessageLocationContactReadResponse',
            'ArrayOfWSMessageLocationContactRead' => '\\MG\\ArrayType\\MGArrayOfWSMessageLocationContactRead',
            'WSMessageLocationContactRead' => '\\MG\\StructType\\MGWSMessageLocationContactRead',
            'ReportMessageContactActivity' => '\\MG\\StructType\\MGReportMessageContactActivity',
            'ReportMessageContactActivityResponse' => '\\MG\\StructType\\MGReportMessageContactActivityResponse',
            'ArrayOfWSMessageContactActivity' => '\\MG\\ArrayType\\MGArrayOfWSMessageContactActivity',
            'WSMessageContactActivity' => '\\MG\\StructType\\MGWSMessageContactActivity',
            'ReportRangeMessageContactRemoval' => '\\MG\\StructType\\MGReportRangeMessageContactRemoval',
            'ReportRangeMessageContactRemovalResponse' => '\\MG\\StructType\\MGReportRangeMessageContactRemovalResponse',
            'ReportMessageContactRemoval' => '\\MG\\StructType\\MGReportMessageContactRemoval',
            'ReportMessageContactRemovalResponse' => '\\MG\\StructType\\MGReportMessageContactRemovalResponse',
            'ReportContactMessageActivity' => '\\MG\\StructType\\MGReportContactMessageActivity',
            'ReportContactMessageActivityResponse' => '\\MG\\StructType\\MGReportContactMessageActivityResponse',
            'ArrayOfWSContactMessageActivity' => '\\MG\\ArrayType\\MGArrayOfWSContactMessageActivity',
            'WSContactMessageActivity' => '\\MG\\StructType\\MGWSContactMessageActivity',
            'ReportListImportHistory' => '\\MG\\StructType\\MGReportListImportHistory',
            'ReportListImportHistoryResponse' => '\\MG\\StructType\\MGReportListImportHistoryResponse',
            'ArrayOfWSImportHistory' => '\\MG\\ArrayType\\MGArrayOfWSImportHistory',
            'WSImportHistory' => '\\MG\\StructType\\MGWSImportHistory',
            'ReportImportContactDetail' => '\\MG\\StructType\\MGReportImportContactDetail',
            'ReportImportContactDetailResponse' => '\\MG\\StructType\\MGReportImportContactDetailResponse',
            'ArrayOfWSImportContact' => '\\MG\\ArrayType\\MGArrayOfWSImportContact',
            'WSImportContact' => '\\MG\\StructType\\MGWSImportContact',
            'ReportListConversationActivity' => '\\MG\\StructType\\MGReportListConversationActivity',
            'ReportListConversationActivityResponse' => '\\MG\\StructType\\MGReportListConversationActivityResponse',
            'ArrayOfWSConversationActivity' => '\\MG\\ArrayType\\MGArrayOfWSConversationActivity',
            'WSConversationActivity' => '\\MG\\StructType\\MGWSConversationActivity',
            'ReportListConversationDelivery' => '\\MG\\StructType\\MGReportListConversationDelivery',
            'ReportListConversationDeliveryResponse' => '\\MG\\StructType\\MGReportListConversationDeliveryResponse',
            'ArrayOfWSConversationDelivery' => '\\MG\\ArrayType\\MGArrayOfWSConversationDelivery',
            'WSConversationDelivery' => '\\MG\\StructType\\MGWSConversationDelivery',
            'ReportConversationContactDelivery' => '\\MG\\StructType\\MGReportConversationContactDelivery',
            'ReportConversationContactDeliveryResponse' => '\\MG\\StructType\\MGReportConversationContactDeliveryResponse',
            'ArrayOfWSConversationContactDelivery' => '\\MG\\ArrayType\\MGArrayOfWSConversationContactDelivery',
            'WSConversationContactDelivery' => '\\MG\\StructType\\MGWSConversationContactDelivery',
            'ReportConversationContactRemoval' => '\\MG\\StructType\\MGReportConversationContactRemoval',
            'ReportConversationContactRemovalResponse' => '\\MG\\StructType\\MGReportConversationContactRemovalResponse',
            'ArrayOfWSConversationContactRemoval' => '\\MG\\ArrayType\\MGArrayOfWSConversationContactRemoval',
            'WSConversationContactRemoval' => '\\MG\\StructType\\MGWSConversationContactRemoval',
            'ReportConversationContactOpen' => '\\MG\\StructType\\MGReportConversationContactOpen',
            'ReportConversationContactOpenResponse' => '\\MG\\StructType\\MGReportConversationContactOpenResponse',
            'ArrayOfWSConversationContactOpen' => '\\MG\\ArrayType\\MGArrayOfWSConversationContactOpen',
            'WSConversationContactOpen' => '\\MG\\StructType\\MGWSConversationContactOpen',
            'ReportConversationContactRead' => '\\MG\\StructType\\MGReportConversationContactRead',
            'ReportConversationContactReadResponse' => '\\MG\\StructType\\MGReportConversationContactReadResponse',
            'ArrayOfWSConversationContactRead' => '\\MG\\ArrayType\\MGArrayOfWSConversationContactRead',
            'WSConversationContactRead' => '\\MG\\StructType\\MGWSConversationContactRead',
            'ReportConversationLinkClick' => '\\MG\\StructType\\MGReportConversationLinkClick',
            'ReportConversationLinkClickResponse' => '\\MG\\StructType\\MGReportConversationLinkClickResponse',
            'ArrayOfWSConversationLinkClick' => '\\MG\\ArrayType\\MGArrayOfWSConversationLinkClick',
            'WSConversationLinkClick' => '\\MG\\StructType\\MGWSConversationLinkClick',
            'ReportConversationContactBounce' => '\\MG\\StructType\\MGReportConversationContactBounce',
            'ReportConversationContactBounceResponse' => '\\MG\\StructType\\MGReportConversationContactBounceResponse',
            'ArrayOfWSConversationContactBounce' => '\\MG\\ArrayType\\MGArrayOfWSConversationContactBounce',
            'WSConversationContactBounce' => '\\MG\\StructType\\MGWSConversationContactBounce',
            'ReportConversationLocationContactOpen' => '\\MG\\StructType\\MGReportConversationLocationContactOpen',
            'ReportConversationLocationContactOpenResponse' => '\\MG\\StructType\\MGReportConversationLocationContactOpenResponse',
            'ArrayOfWSConversationLocationContactOpen' => '\\MG\\ArrayType\\MGArrayOfWSConversationLocationContactOpen',
            'WSConversationLocationContactOpen' => '\\MG\\StructType\\MGWSConversationLocationContactOpen',
            'ReportConversationLocationContactRead' => '\\MG\\StructType\\MGReportConversationLocationContactRead',
            'ReportConversationLocationContactReadResponse' => '\\MG\\StructType\\MGReportConversationLocationContactReadResponse',
            'ArrayOfWSConversationLocationContactRead' => '\\MG\\ArrayType\\MGArrayOfWSConversationLocationContactRead',
            'WSConversationLocationContactRead' => '\\MG\\StructType\\MGWSConversationLocationContactRead',
            'ReportConversationLocationContactClick' => '\\MG\\StructType\\MGReportConversationLocationContactClick',
            'ReportConversationLocationContactClickResponse' => '\\MG\\StructType\\MGReportConversationLocationContactClickResponse',
            'ArrayOfWSConversationLocationContactClick' => '\\MG\\ArrayType\\MGArrayOfWSConversationLocationContactClick',
            'WSConversationLocationContactClick' => '\\MG\\StructType\\MGWSConversationLocationContactClick',
            'GetSystemIDFromPublicID' => '\\MG\\StructType\\MGGetSystemIDFromPublicID',
            'GetSystemIDFromPublicIDResponse' => '\\MG\\StructType\\MGGetSystemIDFromPublicIDResponse',
        );
    }
}
