<?php

namespace MG\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateList StructType
 * @package MG
 * @subpackage Structs
 */
class MGCreateList extends AbstractStructBase
{
    /**
     * The WSList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \MG\StructType\MGWSList
     */
    public $WSList;
    /**
     * The WSException
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \MG\StructType\MGWSException
     */
    public $WSException;
    /**
     * Constructor method for CreateList
     * @uses MGCreateList::setWSList()
     * @uses MGCreateList::setWSException()
     * @param \MG\StructType\MGWSList $wSList
     * @param \MG\StructType\MGWSException $wSException
     */
    public function __construct(\MG\StructType\MGWSList $wSList = null, \MG\StructType\MGWSException $wSException = null)
    {
        $this
            ->setWSList($wSList)
            ->setWSException($wSException);
    }
    /**
     * Get WSList value
     * @return \MG\StructType\MGWSList
     */
    public function getWSList()
    {
        return $this->WSList;
    }
    /**
     * Set WSList value
     * @param \MG\StructType\MGWSList $wSList
     * @return \MG\StructType\MGCreateList
     */
    public function setWSList(\MG\StructType\MGWSList $wSList = null)
    {
        $this->WSList = $wSList;
        return $this;
    }
    /**
     * Get WSException value
     * @return \MG\StructType\MGWSException
     */
    public function getWSException()
    {
        return $this->WSException;
    }
    /**
     * Set WSException value
     * @param \MG\StructType\MGWSException $wSException
     * @return \MG\StructType\MGCreateList
     */
    public function setWSException(\MG\StructType\MGWSException $wSException = null)
    {
        $this->WSException = $wSException;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \MG\StructType\MGCreateList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
