<?php

namespace MG\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendListMessageTest StructType
 * @package MG
 * @subpackage Structs
 */
class MGSendListMessageTest extends AbstractStructBase
{
    /**
     * The WSMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \MG\StructType\MGWSMessage
     */
    public $WSMessage;
    /**
     * The TestEmailAddress
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TestEmailAddress;
    /**
     * Constructor method for SendListMessageTest
     * @uses MGSendListMessageTest::setWSMessage()
     * @uses MGSendListMessageTest::setTestEmailAddress()
     * @param \MG\StructType\MGWSMessage $wSMessage
     * @param string $testEmailAddress
     */
    public function __construct(\MG\StructType\MGWSMessage $wSMessage = null, $testEmailAddress = null)
    {
        $this
            ->setWSMessage($wSMessage)
            ->setTestEmailAddress($testEmailAddress);
    }
    /**
     * Get WSMessage value
     * @return \MG\StructType\MGWSMessage
     */
    public function getWSMessage()
    {
        return $this->WSMessage;
    }
    /**
     * Set WSMessage value
     * @param \MG\StructType\MGWSMessage $wSMessage
     * @return \MG\StructType\MGSendListMessageTest
     */
    public function setWSMessage(\MG\StructType\MGWSMessage $wSMessage = null)
    {
        $this->WSMessage = $wSMessage;
        return $this;
    }
    /**
     * Get TestEmailAddress value
     * @return string|null
     */
    public function getTestEmailAddress()
    {
        return $this->TestEmailAddress;
    }
    /**
     * Set TestEmailAddress value
     * @param string $testEmailAddress
     * @return \MG\StructType\MGSendListMessageTest
     */
    public function setTestEmailAddress($testEmailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($testEmailAddress) && !is_string($testEmailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($testEmailAddress)), __LINE__);
        }
        $this->TestEmailAddress = $testEmailAddress;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \MG\StructType\MGSendListMessageTest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
