<?php

namespace MG\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendListMessageWithProfileFilter StructType
 * @package MG
 * @subpackage Structs
 */
class MGSendListMessageWithProfileFilter extends AbstractStructBase
{
    /**
     * The WSMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var \MG\StructType\MGWSMessage
     */
    public $WSMessage;
    /**
     * The ProfileFilter
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \MG\ArrayType\MGArrayOfWSProfileFilter
     */
    public $ProfileFilter;
    /**
     * Constructor method for SendListMessageWithProfileFilter
     * @uses MGSendListMessageWithProfileFilter::setWSMessage()
     * @uses MGSendListMessageWithProfileFilter::setProfileFilter()
     * @param \MG\StructType\MGWSMessage $wSMessage
     * @param \MG\ArrayType\MGArrayOfWSProfileFilter $profileFilter
     */
    public function __construct(\MG\StructType\MGWSMessage $wSMessage = null, \MG\ArrayType\MGArrayOfWSProfileFilter $profileFilter = null)
    {
        $this
            ->setWSMessage($wSMessage)
            ->setProfileFilter($profileFilter);
    }
    /**
     * Get WSMessage value
     * @return \MG\StructType\MGWSMessage
     */
    public function getWSMessage()
    {
        return $this->WSMessage;
    }
    /**
     * Set WSMessage value
     * @param \MG\StructType\MGWSMessage $wSMessage
     * @return \MG\StructType\MGSendListMessageWithProfileFilter
     */
    public function setWSMessage(\MG\StructType\MGWSMessage $wSMessage = null)
    {
        $this->WSMessage = $wSMessage;
        return $this;
    }
    /**
     * Get ProfileFilter value
     * @return \MG\ArrayType\MGArrayOfWSProfileFilter|null
     */
    public function getProfileFilter()
    {
        return $this->ProfileFilter;
    }
    /**
     * Set ProfileFilter value
     * @param \MG\ArrayType\MGArrayOfWSProfileFilter $profileFilter
     * @return \MG\StructType\MGSendListMessageWithProfileFilter
     */
    public function setProfileFilter(\MG\ArrayType\MGArrayOfWSProfileFilter $profileFilter = null)
    {
        $this->ProfileFilter = $profileFilter;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \MG\StructType\MGSendListMessageWithProfileFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
